Description: Creates permanent resources for the rS future-goat front-end component.

Parameters:

  VerticalName:
    Description: Short version of the Vertical (Team) name.
    Type: String
    Default: rad

  EnvironmentName:
    Description: The name of the target environment.
    Type: String
    AllowedValues: [dev]

  IsDomainRoot:
    Description: Sets if the static site handles 'www.domain.com' and 'domain.com' requests.
    Type: String
    Default: 'false'
    AllowedValues: ['true', 'false']

  DNSName:
    Description: >
      The name of the alias created for the CloudFrontDistribution. If not
      specified, ${EnvironmentName}-${ProjectName} will be used.
    Type: String
    Default: ''

  DNSAliases:
    Description: >
      The name of the vanity urls created for the CloudFrontDistribution. If multiple
      vanity urls are desired, a comma separated list should be provided.
    Type: String
    Default: ''

  DomainName:
    Description: The root domain name to register the site within. i.e. example.com
    Type: String
    AllowedPattern: "^(?:[0-9a-zA-Z_\\-]+\\.)+[0-9a-zA-Z_\\-]+$"

  HostedZoneId:
    Description: HostedZoneId
    Type: String

Mappings:
  Inventory:
    Project:
      Name: future-goat
    CloudFormation:
      BaseUrl: https://s3.amazonaws.com/cloudformation.liketoknow.it/templates
      Version: 9131f0418c54f2ca871de43875857a310f84328f

Resources:
  StaticSite:
    Type: AWS::CloudFormation::Stack
    Properties:
      TemplateURL: !Sub
        - ${BaseUrl}/${Version}/shared/cloudfront/static-site.yml
        - BaseUrl: !FindInMap [Inventory, CloudFormation, BaseUrl]
          Version: !FindInMap [Inventory, CloudFormation, Version] 
      Parameters:
        EnvironmentName: !Ref EnvironmentName
        ProjectName: future-goat
        IsDomainRoot: !Ref IsDomainRoot
        VerticalName: !Ref VerticalName
        DNSName: !Ref DNSName
        DNSAliases: !Ref DNSAliases
        DomainName: !Ref DomainName
        HostedZoneId: !Ref HostedZoneId
